from multiprocessing import Process,Lock,Queue
import numpy as np
import scipy.integrate as si

processors=4
xlim_inf=0
xlim_sup=1
queue=Queue()
lock=Lock()

def f (x):

  return 4./(1+x*x)

def xlim (min,max,p,i):
  '''
	Set the limits of the integration for the i-th work of a n work pool
        for a global integration from min to max
  '''
  dx=(max-min)*1./p
  return (min + i*dx, min + (i+1)*dx)

def integrator (i):
  '''
	Integrate f(x) using the limits given by xlim using scipy.quad method
  '''
  xinf,xsup=xlim(xlim_inf,xlim_sup,processors,i)
  queue.put(si.quad(lambda x: f(x),xinf,xsup)[0])

if __name__=="__main__":

  processes=[]
  for i in xrange(processors):

    p=Process(target=integrator,args=(i,))
    processes.append(p)
    p.start()

  for p in processes: p.join()
  result=0
  for p in processes: result+= queue.get()

  print result


